diff --git a/src/yb/client/transaction.cc b/src/yb/client/transaction.cc
index b9ad0c7703b8..22a7c8f332e3 100644
--- a/src/yb/client/transaction.cc
+++ b/src/yb/client/transaction.cc
@@ -162,7 +162,6 @@ class YBTransaction::Impl final : public internal::TxnBatcherIf {
  public:
   Impl(TransactionManager* manager, YBTransaction* transaction, TransactionLocality locality)
       : trace_(Trace::NewTrace()),
-        start_(CoarseMonoClock::Now()),
         manager_(manager),
         transaction_(transaction),
         read_point_(manager->clock()),
@@ -175,7 +174,6 @@ class YBTransaction::Impl final : public internal::TxnBatcherIf {
 
   Impl(TransactionManager* manager, YBTransaction* transaction, const TransactionMetadata& metadata)
       : trace_(Trace::NewTrace()),
-        start_(CoarseMonoClock::Now()),
         manager_(manager),
         transaction_(transaction),
         metadata_(metadata),
@@ -187,7 +185,6 @@ class YBTransaction::Impl final : public internal::TxnBatcherIf {
 
   Impl(TransactionManager* manager, YBTransaction* transaction, ChildTransactionData data)
       : trace_(Trace::NewTrace()),
-        start_(CoarseMonoClock::Now()),
         manager_(manager),
         transaction_(transaction),
         read_point_(manager->clock()),
@@ -219,13 +216,16 @@ class YBTransaction::Impl final : public internal::TxnBatcherIf {
     const auto threshold = GetAtomicFlag(&FLAGS_txn_slow_op_threshold_ms);
     const auto print_trace_every_n = GetAtomicFlag(&FLAGS_txn_print_trace_every_n);
     const auto now = CoarseMonoClock::Now();
+    // start_ is not set if Init is not called - this happens for transactions that get
+    // aborted without doing anything, so we set time_spent to 0 for these transactions.
+    const auto time_spent = now - (start_ == CoarseTimePoint() ? now : start_);
     if ((trace_ && trace_->must_print())
-           || (threshold > 0 && ToMilliseconds(now - start_) > threshold)) {
-      LOG(INFO) << ToString() << " took " << ToMicroseconds(now - start_) << "us. Trace: \n"
+           || (threshold > 0 && ToMilliseconds(time_spent) > threshold)) {
+      LOG(INFO) << ToString() << " took " << ToMicroseconds(time_spent) << "us. Trace: \n"
         << (trace_ ? trace_->DumpToString(true) : "Not collected");
     } else if (trace_) {
       YB_LOG_IF_EVERY_N(INFO, print_trace_every_n > 0, print_trace_every_n)
-        << ToString() << " took " << ToMicroseconds(now - start_) << "us. Trace: \n"
+        << ToString() << " took " << ToMicroseconds(time_spent) << "us. Trace: \n"
         << trace_->DumpToString(true);
     }
   }
@@ -987,6 +987,7 @@ class YBTransaction::Impl final : public internal::TxnBatcherIf {
     } else {
       metadata_.start_time = read_point_.Now();
     }
+    start_ = CoarseMonoClock::Now();
   }
 
   void SetReadTimeIfNeeded(bool do_it) {
@@ -1921,7 +1922,7 @@ class YBTransaction::Impl final : public internal::TxnBatcherIf {
   // The trace buffer.
   scoped_refptr<Trace> trace_;
 
-  const CoarseTimePoint start_;
+  CoarseTimePoint start_;
 
   // Manager is created once per service.
   TransactionManager* const manager_;
